import jp.jig.jiglet.*;

public class sl extends Jiglet {
	String[] D51STR =
	{
		"      ====        ________                ___________ ",
		"  _D _|  |_______/        \\__I_I_____===__|_________| ",
		"   |(_)---  |   H\\________/ |   |        =|___ ___|   ",
		"   /     |  |   H  |  |     |   |         ||_| |_||   ",
		"  |      |  |   H  |__--------------------| [___] |   ",
		"  | ________|___H__/__|_____/[][]~\\_______|       |   ",
		"  |/ |   |-----------I_____I [][] []  D   |=======|__ ",
	};

	String[][] D51WHEEL =
	{
		{
			"__/ =| o |=-~~\\  /~~\\  /~~\\  /~~\\ ____Y___________|__ ",
			" |/-=|___|=    ||    ||    ||    |_____/~\\___/        ",
			"  \\_/      \\O=====O=====O=====O_/      \\_/            ",
		},
		{
			"__/ =| o |=-~~\\  /~~\\  /~~\\  /~~\\ ____Y___________|__ ",
			" |/-=|___|=O=====O=====O=====O   |_____/~\\___/        ",
			"  \\_/      \\__/  \\__/  \\__/  \\__/      \\_/            ",
		},
		{
			"__/ =| o |=-O=====O=====O=====O \\ ____Y___________|__ ",
			" |/-=|___|=    ||    ||    ||    |_____/~\\___/        ",
			"  \\_/      \\__/  \\__/  \\__/  \\__/      \\_/            ",
		},
		{
			"__/ =| o |=-~O=====O=====O=====O\\ ____Y___________|__ ",
			" |/-=|___|=    ||    ||    ||    |_____/~\\___/        ",
			"  \\_/      \\__/  \\__/  \\__/  \\__/      \\_/            ",
		},
		{
			"__/ =| o |=-~~\\  /~~\\  /~~\\  /~~\\ ____Y___________|__ ",
			" |/-=|___|=   O=====O=====O=====O|_____/~\\___/        ",
			"  \\_/      \\__/  \\__/  \\__/  \\__/      \\_/            ",
		},
		{
			"__/ =| o |=-~~\\  /~~\\  /~~\\  /~~\\ ____Y___________|__ ",
			" |/-=|___|=    ||    ||    ||    |_____/~\\___/        ",
			"  \\_/      \\_O=====O=====O=====O/      \\_/            ",
		}
	};
	String[] COAL =
	{
		"                              ",
		"                              ",
		"    _________________         ",
		"   _|                \\_____A  ",
		" =|                        |  ",
		" -|                        |  ",
		"__|________________________|_ ",
		"|__________________________|_ ",
		"   |_D__D__D_|  |_D__D__D_|   ",
		"    \\_/   \\_/    \\_/   \\_/    ",
	};
	String STEAM[][] =
	{
		{
			"                      (@@) (  ) (@)  ( )  @@    ()    @     O     @     O      @",
			"                 (   )",
			"             (@@@@)",
			"          (    )",
			"",
			"        (@@@)",
		},
		{
			"                      (  ) (@@) ( )  (@)  ()    @@    O     @     O     @      O",
			"                 (@@@)",
			"             (    )",
			"          (@@@@)",
			"",
			"        (   )",
		}
	};

	int xChars;
	int yLines;
	int wChar;
	int wAllCars;
	int hBox;
	int idWheel;
	int idSteam;
	int innerCount;
	boolean ready = false;
	boolean isRunning = false;
	public void paint(boolean allDrawFlag) {
		if (! ready) {
			return;
		}

		/* background box */
		setColor(0x000000);
		fillRect(0, (DH - yLines) / 2, DW, yLines);

		/* train */
		if (isRunning) {
			setColor(0xffffff);
			for (int i = 0; i < STEAM[idSteam].length; i++) {
				drawString(STEAM[idSteam][i], xChars * wChar, (DH - yLines) / 2 + (i + 1) * getFontHeight());
			}
			for (int i = 0; i < D51STR.length; i++) {
				drawString(D51STR[i] + COAL[i], xChars * wChar, (DH - yLines) / 2 + (i + STEAM[idSteam].length) * getFontHeight());
			}
			for (int i = 0; i < D51WHEEL[idWheel].length; i++) {
				drawString(D51WHEEL[idWheel][i] + COAL[i + D51STR.length - 1],
					xChars * wChar, (DH - yLines) / 2 + (i + STEAM[idSteam].length + D51STR.length) * getFontHeight());
			}
		}
	}
	
	public void main() {
		/* select minimum size */
		setFontSize(1);
		repaintAll();

		hBox = getFontHeight() * (COAL.length + STEAM[0].length);
		wAllCars = 0 - (D51STR[0].length() + COAL[0].length());

		ready = true;

		/* appearing animation */
		for (yLines = 0; yLines < hBox; yLines += 4) {
			repaintAll();
		}

		/* train running */
		isRunning = true;
		idWheel = 0;
		for (xChars = DW / (wChar = stringWidth("W")); xChars > wAllCars; xChars--) {
			repaintAll();
			innerCount++;
			idWheel = D51WHEEL.length - ((innerCount / 2) % D51WHEEL.length) - 1;
			idSteam = (innerCount / 4) % STEAM.length;
		}

		isRunning = false;

		/* closing animation */
		for (yLines = hBox; yLines > 0; yLines -= 4) {
			repaintAll();
		}

		terminate();
	}
}
